{
    Respond, the fax number form daemon
    Copyright (C) 2000 Horst F <horstf@gmx.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit Rootfrm;

// Use dWinsock as default
{$IFNDEF ICS}
  {$IFNDEF DWINSOCK}
    {$DEFINE DWINSOCK}
  {$ENDIF}
{$ENDIF}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus,
{$IFDEF WIN32}
  TrayIcon,
{$ENDIF}
{$IFDEF ICS}
  WSocket, WSocketS,
{$ENDIF}
{$IFDEF DWINSOCK}
  BuffSock, DWinSock, WsAPI,
{$ENDIF}
  Respfrm, Header, PhBook, Histfrm, AboutFrm, Morefrm, IniFile,
  Observer, CommonDataAccess, History, ObservedStringList;

type
{$IFDEF ICS}
  TWLineSocket = class(TWSocketClient)
  public
    procedure WriteLine(const s: String);
  end;
{$ENDIF}

  TRootForm = class(TForm)
{$IFDEF ICS}
    procedure WSSocketClientDisconnect(Sender: TObject;
      Socket: TWSocketClient; Error: Word);
    procedure WSSocketClientConnect(Sender: TObject;
      Socket: TWSocketClient; Error: Word);
{$ENDIF}
{$IFDEF DWINSOCK}
    procedure SSocketAccept(Sender: TObject; Socket: TSocketBase);
    procedure SSocketDisconnect(Sender: TObject; Socket: TSocketBase);
{$ENDIF}
{$IFNDEF WIN32}
    procedure wmSysCommand( var Msg : TMsg; var Handled : Boolean );
{$ENDIF}
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
{$IFDEF WIN32}
    TrayIcon: TTrayIcon;
{$ENDIF}
{$IFDEF ICS}
    WSSocket: TWSocketServer;
{$ENDIF}
{$IFDEF DWINSOCK}
    SSocket: TTextServer;
{$ENDIF}
{$IFNDEF WIN32}
//    Appended : Boolean;         {Systemmenu extended}
    SysMenu : HMenu;
    NetApi : THandle;
{$ENDIF}
    wartend, angenommen : String;
{$IFDEF ICS}
    CSocket : TWLineSocket;  {Active socket}
{$ENDIF}
{$IFDEF DWINSOCK}
    CSocket : TLineSocket;      {Active socket}
{$ENDIF}
{$IFDEF WIN32}
    procedure MenuClose( Sender: TObject );
    procedure AppMinimize(Sender: TObject);
{$ENDIF}
    procedure WMQueryOpen(VAR Msg : TWMQueryOpen); message WM_QUERYOPEN;
    procedure MenuAbout( Sender: TObject );
    procedure MenuPBook(Sender: TObject);
  public
    { Public-Deklarationen }
    procedure MainFormOKBtnClick(Sender: TObject);
    procedure MainFormCancelBtnClick(Sender: TObject);
    procedure FlushDatabases;
  end;

var
  RootForm: TRootForm;

implementation

{$IFNDEF WIN32}
const
  // wmSysCommand: wParam-values for system menu items
  //               last 4 Bits have to be 0 (reserved for Windows)
  SC_ABOUT = $0020;
  SC_PBOOK = $0030;

type
  TNetWkStaGetInfo = function( pszServer : PChar; sLevel : Integer;
                               pbBuffer : PChar; cbBuffer : Word;
                               pcbTotalAvail : PWord) : Word;

var
  NetWkStaGetInfo : TNetWkStaGetInfo;
  LibLoaded : Boolean;               // NETAPI.DLL loaded
{$ENDIF}

{$R *.DFM}

function GetUserName : String;
{$IFDEF WIN32}
const
  DBuf : array[0..255]of char = '';
var
  DType : DWORD;
  BufSiz : DWORD;
  KeyHandle: HKEY;
begin
  BufSiz := 255;
  WNetGetUser(nil, @DBuf, BufSiz);  // Get the local username
  if StrLen(@DBuf) = 0 then begin
    BufSiz := 255;
    // Ask registry for username
    RegOpenKeyEx( HKEY_LOCAL_MACHINE, UserNameKey, 0, KEY_QUERY_VALUE,
        KeyHandle );
    RegQueryValueEx( KeyHandle, UserNameValue, nil, @DType, @DBuf, @BufSiz );
    RegCloseKey( KeyHandle );
  end;
  Result := StrPas( @DBuf );
{$ELSE}
// Use NETAPI.DLL to get the user name, read SYSTEM.INI if this fails
type
  TWkSta_info_10 = record
    wki_computername : PChar;	// name of computer
    wki_username : PChar;	// name of logged on user
    wki_langroup : PChar;	// name of workgroup
    wki_ver_major : Byte;	// major version number
    wki_ver_minor : Byte;	// minor version number
    wki_logon_domain : PChar;	// name of logon workgroup
    wki_oth_domains : PChar;	// reserved; must be zero
  end;

var
  TotalSize, Res, Size : Word;
  Wki : TWkSta_info_10;
  p : array[0..255]of char;
Begin
  Result := '';
  // only if NETAPI.DLL loaded
  if LibLoaded then
    if NetWkstaGetInfo(nil,10,@wki,SizeOf(Wki),@TotalSize) = 0 then
      Result := StrPas(wki.wki_UserName);
  if Result = '' then begin
    GetPrivateProfileString( 'Network', 'UserName', '', @p, 255, 'SYSTEM.INI' );
    Result := StrPas( @p );
  end;
{$ENDIF}
end;

{$IFDEF ICS}
procedure TWLineSocket.WriteLine(const s: String);
begin
  SendStr(s + #13#10);
end;
{$ENDIF}

{$IFDEF ICS}
procedure TRootForm.WSSocketClientConnect(Sender: TObject;
  Socket: TWSocketClient; Error: Word);
{$ENDIF}
{$IFDEF DWINSOCK}
procedure TRootForm.SSocketAccept(Sender: TObject;
  Socket: TSocketBase);
{$ENDIF}
{ a host calls us }
var
  s : String;
begin
  If CSocket = nil then begin
{$IFDEF ICS}
    CSocket := Socket as TWLineSocket;
{$ENDIF}
{$IFDEF DWINSOCK}
    CSocket := Socket as TLineSocket;
{$ENDIF}
    FlushDatabases;
    { prepare Respond window }
    MainForm := TMainForm.Create(Self);
    s := '';
{$IFDEF ICS}
    if s = '' then s := Socket.GetPeerAddr;
{$ENDIF}
{$IFDEF DWINSOCK}
    if TCommonData.ReadInteger(OptionsSection, LookupHostKey, 0) <> 0 then
      try
        s := Socket.RemoteHost;
      except
        on E:ESockError do;
      end;
    if s = '' then s := Socket.RemoteAddress;
{$ENDIF}
    Caption := CProgName;
{$IFDEF WIN32}
    TrayIcon.ToolTip := CProgName;
{$ENDIF}
    with MainForm do begin
      Caption := angenommen+s;
      if Nutzer.Visible then
        Nutzer.Text := GetUserName;
{$IFDEF DEBUG}
      Empfaenger.Text := IntToStr(ObjectObserver.Count);
{$ENDIF}      
      OKBtn.OnClick := MainFormOKBtnClick;
      CancelBtn.OnClick := MainFormCancelBtnClick;
      Show;
{$IFNDEF WIN32}
      { Needed for 16bit version with win95 to show window above all other }
      SetWindowPos( handle, HWND_TOPMOST, Left, Top, Width, Height,
                    SWP_NOSIZE or SWP_NOMOVE );
      { and now remove TOPMOST status }
      SetWindowPos( handle, HWND_TOP, Left, Top, Width, Height,
                    SWP_NOSIZE or SWP_NOMOVE );
{$ELSE}
      SetForegroundWindow( handle );
{$ENDIF}
      Eingabe.SetFocus;
      Eingabe.SelectAll;
    end;
  end else Socket.Close;      { allow only one connection at the same time }
end;

{$IFDEF ICS}
procedure TRootForm.WSSocketClientDisconnect(Sender: TObject;
  Socket: TWSocketClient; Error: Word);
{ Remote host has closed connection }
begin
  if Socket = CSocket then begin
    Socket.Close;
    MainForm.Close;
    MainForm.Free;
    Caption := wartend;
{$IFDEF WIN32}
    TrayIcon.ToolTip := wartend;
{$ENDIF}
    CSocket := nil;
  end else Socket.Abort;
end;
{$ENDIF}

{$IFDEF DWINSOCK}
procedure TRootForm.SSocketDisconnect(Sender: TObject;
  Socket: TSocketBase);
{ Remote host has closed connection }
begin
  Socket.Close;
  MainForm.Close;
  MainForm.Free;
  Caption := wartend;
{$IFDEF WIN32}
  TrayIcon.ToolTip := wartend;
{$ENDIF}
  CSocket := nil;
end;
{$ENDIF}

{$IFDEF WIN32}
procedure TRootForm.AppMinimize(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE);
end;
{$ENDIF}

procedure TRootForm.WMQueryOpen(VAR Msg : TWMQueryOpen);
{ prevent window open }
begin
  Msg.Result := 0
end;

procedure TRootForm.FormCreate(Sender: TObject);
var
{  s : String;
  i : Integer;}
{$IFNDEF WIN32}
  ProcAddress : TFarProc;
{$ELSE}
  MenuItem : TMenuItem;
{$ENDIF}
  sl : TObservedStringList;
begin
{$IFDEF WIN32}
  ShowWindow( Handle, SW_HIDE );
  Application.OnMinimize := AppMinimize;
{$ENDIF}
  { Process comandline options }
  ProcessOptions;
  MoreStrings := nil;
  TCommonData.BindTableToIniFile(OptionsSection, OptionsFile);
  TCommonData.BindTableToIniFile(LabelsSection, LabelFile);
  TCommonData.BindTableToIniFile(HistorySection, HistoryFile);
  if Length(CommonPhonebookFile) > 0 then begin
    TCommonData.BindTableToIniFile(AliasSection, CommonPhonebookFile);
    // Because the private phonebook uses the same alias, we have to switch
    // the (internal) alias for the common phonebook
    TCommonData.SetTableAlias(AliasSection, CommonPhonebookSection);
  end;
  TCommonData.BindTableToIniFile(PrivatePhonebookSection, PrivatePhonebookFile);

  // Define fields for "fielded" tables
  sl := nil;
  try
    sl := TObservedStringList.Create;
    sl.Add('Alias');
    sl.Add('Fax');
    sl.Add('Name');
    TCommonData.DefineFields(CommonPhonebookSection, sl);
    TCommonData.DefineFields(PrivatePhonebookSection, sl);
    // No Free here for sl, because it's stored in tab description!!!
    sl := TObservedStringList.Create;
    sl.Add('Fax');
    sl.Add('Name');
    TCommonData.DefineFields(HistorySection, sl);
    // No Free here for sl, because it's stored in tab description!!!
  except
    on EOutOfMemory do begin
      MessageDlg(GetLabelStr(KIErrOutOfMemory), mtError, [mbOK], 0);
      sl.Free;
      Application.Terminate;
    end;
  end;
  CSocket := nil;
  GetLabelPChar(KIAbout, @AboutMenuItemString, 255 );
  GetLabelPChar(KIPhoneBook, @PBookMenuItemString, 255 );
  angenommen := CProgName+': '+GetLabelStr(KIQueryFrom)+' ';
  wartend := CProgName+' ('+GetLabelStr(KIWaiting)+')';
  Caption := wartend;
{$IFNDEF WIN32}
  // Try to load NETAPI.DLL but only if it is allowed (prevent error message in
  // Win31/WinNT which do not have one)
  LibLoaded := False;
  if TCommonData.ReadInteger(OptionsSection, LoadNetAPIKey, 0) <> 0) then begin
    // load NETAPI.DLL dynamically
    NetAPI := LoadLibrary( 'NETAPI.DLL' );
    if not ( NetAPI < HINSTANCE_ERROR) then begin
      ProcAddress := getprocaddress( NetAPI, 'NetWkStaGetInfo' );
      // Free DLL if function not found }
      if ProcAddress = nil then FreeLibrary( NetAPI )
      else begin
        NetWkStaGetInfo := TNetWkStaGetInfo( ProcAddress );
        LibLoaded := True;           { DLL loaded and function found}
      end;
    end;
  end;
  { Change system menu }
  Appended := False;
  Application.OnMessage := wmSysCommand;
  SysMenu := GetSystemMenu( Handle, False );
  AppendMenu( SysMenu, MF_SEPARATOR, 0, '' );
  AppendMenu( SysMenu, MF_STRING, SC_ABOUT, AboutMenuItem );
  AppendMenu( SysMenu, MF_STRING, SC_PBOOK, PBookMenuItem );
  Appended := True;
{$ELSE}
  { Create PopupMenu }
  try
    TrayIcon := TTrayIcon.Create(self);
    GetLabelPChar(KIClose, @CloseMenuItemString, 255 );
    with TrayIcon do begin
      TrayIcon.Icon := Application.Icon;
      TrayIcon.PopupMenu := TPopupMenu.Create(Self);
      MenuItem := TMenuItem.Create(Self);
      MenuItem.Caption := StrPas(CloseMenuItem);
      MenuItem.OnClick := MenuClose;
      TrayIcon.PopupMenu.Items.Add(MenuItem);
      MenuItem := TMenuItem.Create(Self);
      MenuItem.Caption := StrPas(AboutMenuItem);
      MenuItem.OnClick := MenuAbout;
      TrayIcon.PopupMenu.Items.Add(MenuItem);
      MenuItem := TMenuItem.Create(Self);
      MenuItem.Caption := StrPas(PBookMenuItem);
      MenuItem.OnClick := MenuPBook;
      TrayIcon.PopupMenu.Items.Add(MenuItem);
      TrayIcon.ToolTip := Caption;
      TrayIcon.Active := True;
    end;
  except
    on EOutOfMemory do begin
      MessageDlg(GetLabelStr(KIErrOutOfMemory), mtError, [mbOK], 0);
      Application.Terminate;
    end;
  end;
{$ENDIF}
  { Listen }
{$IFDEF ICS}
  try
    WSSocket := TWSocketServer.Create(self);
  except
    on EOutOfMemory do begin
      MessageDlg(GetLabelStr(KIErrOutOfMemory), mtError, [mbOK], 0);
      Application.Terminate;
    end;
  end;
  with WSSocket do begin
    Banner := '';
    BannerToBusy := '';
    LineMode := True;
    MaxClients := 1;
    Port := IntToStr(TCommonData.ReadInteger(OptionsSection,
        PortValueKey, DefaultPort));
    ClientClass := TWLineSocket;
    OnClientConnect := WSSocketClientConnect;
    OnClientDisconnect := WSSocketClientDisconnect;
  end;
  try
    WSSocket.Listen;
  except
    on E:ESocketException do begin
      MessageDlg( E.Message, mtError, [mbOK], 0 );
      Application.Terminate;
    end;
  end;
{$ENDIF}
{$IFDEF DWINSOCK}
  try
    SSocket := TTextServer.Create(self);
  except
    on EOutOfMemory do begin
      MessageDlg(GetLabelStr(KIErrOutOfMemory), mtError, [mbOK], 0);
      Application.Terminate;
    end;
  end;
  with SSocket do begin
    ClientOptions := [csoRead];
    LineOptions := [lsoAddLineChars, lsoAutoFlushAfterWrite];
    MaxConnections := 1;
    Port := IntToStr(TCommonData.ReadInteger(OptionsSection,
        PortValueKey, DefaultPort));
    QueueLength := 1;
    OnAccept := SSocketAccept;
    OnDisconnect := SSocketDisconnect;
  end;
  try
    SSocket.Listen(TLineSocket);
  except
    on E:ESockError do begin
      MessageDlg( E.Message, mtError, [mbOK], 0 );
      Application.Terminate;
    end;
  end;
{$ENDIF}
end;

procedure TRootForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  // Don't listen any more
{$IFDEF ICS}
  WSSocket.Close;
{$ENDIF}
{$IFDEF DWINSOCK}
  SSocket.CloseDown;
{$ENDIF}
{$IFNDEF WIN32}
  SysMenu := GetSystemMenu( Handle, True );  { Restore system menu }
{$ELSE}
  TrayIcon.Active := False;
{$ENDIF}
{$IFNDEF WIN32}
  if LibLoaded then FreeLibrary( NetAPI );   { Free NETAPI.DLL }
{$ENDIF}
  FlushDatabases;
  Action := caFree;                          { Free all form memory }
end;

procedure TRootForm.FormDestroy(Sender: TObject);
begin
{$IFDEF WIN32}
  TrayIcon.PopupMenu.Free;
{$ENDIF}
  TCommonData.ReleaseTable(HistorySection);
  TCommonData.ReleaseTable(AliasSection);
  TCommonData.ReleaseTable(OptionsSection);
  if MoreStrings <> nil then begin
    MoreStrings.Clear;
    MoreStrings.Free;
    MoreStrings := nil;
  end;
end;

{$IFNDEF WIN32}
procedure TRootForm.wmSysCommand( var Msg : TMsg; var Handled : Boolean );
{ Process system menu commands }
begin
  Handled := False;
  if Msg.Message = WM_SYSCOMMAND then begin
    case ( Msg.wParam and $FFF0 ) of
    SC_ABOUT : begin
        { Show aboutbox }
        MenuAbout(Self);
        Handled := True;   { Command processed }
      end;
    SC_PBOOK : begin
        { Show phonebook }
        MenuPBook(Self);
        Handled := True;   { Command processed }
      end;
    end;
  end;
end;

{$ELSE}

procedure TRootForm.MenuClose( Sender: TObject );
begin
  {Application.Terminate;}
  Close;
end;
{$ENDIF}

procedure TRootForm.MenuAbout( Sender: TObject );
{ ShowModal aboutbox }
var
  form : TAboutBox;
begin
  form := nil;
  try
    form := TAboutBox.Create( Self );
    form.ShowModal;
  except
    on EOutOfMemory do begin;
      MessageDlg(GetLabelStr(KIErrOutOfMemory), mtError, [mbOK], 0);
    end;
  end;
  form.Free;
end;

procedure TRootForm.MenuPBook(Sender: TObject);
{ ShowModal phonebook }
var
  form : TPhBookForm;
begin
  form := nil;
  try
    form := TPhBookForm.Create(Self);
    form.ShowModal;
  except
    on EOutOfMemory do begin;
      MessageDlg(GetLabelStr(KIErrOutOfMemory), mtError, [mbOK], 0);
    end;
  end;
  form.Free;
end;

procedure TRootForm.MainFormOKBtnClick(Sender: TObject);
{ OK button in query form clicked; send input }
var
  i : Integer;
  s, allnumbers, number, receiver : String;
  p : array[0..255]of Char;
  p1, p2 : PChar;
  sl : TObservedStringList;
begin
  if CSocket <> nil then with MainForm do begin
    allnumbers := '';
    receiver := '';
    s := Trim(Eingabe.Text);
    if Length(s) > 0 then begin
      THistory.Add( s, Empfaenger.Text );
      StrPCopy(@p, s);
      p1 := @p;
      try
        sl := TObservedStringList.Create;
      except
        on EOutOfMemory do begin
          MessageDlg(GetLabelStr(KIErrOutOfMemory), mtError, [mbOK], 0);
          exit;
        end;
      end;
      while p1^ <> #0 do begin
        while (p1^ in SeparatorChars) and ( p1^<>#0 ) do Inc(p1);
        p2 := p1;
        while not (p1^ in SeparatorChars) and ( p1^<>#0 ) do Inc(p1);
        if p1^ <> #0 then begin
          p1^ := #0;
          Inc(p1);
        end;
        if p2^ <> #0 then begin
          sl.Clear;
          // p2 points to the entered alias, now get the number and receiver
          TCommonData.ReadFields(PrivatePhonebookSection, StrPas(p2), sl);
          if sl.Count = 0 then begin
            TCommonData.ReadFields(CommonPhonebookSection, StrPas(p2), sl);
          end;
          if sl.Count > 0 then begin
            number := sl.Strings[0];
            if sl.Count > 1 then begin
              if Length(allnumbers) = 0 then receiver := sl.Strings[1]
              else receiver := '';
            end;
          end else begin
            number := StrPas(p2);
          end;
          AppendStr(allnumbers, ' ' + number);
        end;
      end;
      sl.Free;
    end;
    allnumbers := Trim(allnumbers);
    if Length(allnumbers) > 0 then begin
      if Empfaenger.Text = '' then Empfaenger.Text := receiver;
      CSocket.WriteLine(allnumbers);
      CSocket.WriteLine(Nutzer.Text);
      if Empfaenger.Visible then CSocket.WriteLine(Empfaenger.Text)
                        else CSocket.WriteLine('');
      if Name.Visible then CSocket.WriteLine(Name.Text)
                        else CSocket.WriteLine('');
      if Delayed <> dOff then begin
        case Delayed of
        dCheck: begin
            if DelayedCheck.Checked then CSocket.WriteLine('delayed');
    {        DelayedCheck.Checked := False;}
          end;
        dEdit: begin
            CSocket.WriteLine(DelayedEdit.Text);
    {        DelayedEdit.Text := '';}
          end;
        else CSocket.WriteLine('');
        end;
      end else CSocket.WriteLine('');
      if (MoreStrings <> nil) and (MoreStrings.Count > 0) then begin
        for i := 0 to MoreStrings.Count-1 do
          CSocket.WriteLine(MoreStrings[i]);
      end;
      CSocket.Close;    { Close connection after sending }
      Close;
      Release;
      if TCommonData.ReadInteger(OptionsSection, RememberMoreKey, 0) = 0
          then begin
        MoreStrings.Free;
        MoreStrings := nil;
      end;
      Caption := wartend;
      CSocket := nil;
    end else Eingabe.SetFocus;
  end;
end;

procedure TRootForm.MainFormCancelBtnClick(Sender: TObject);
{ Cancel button in query form clicked; close connection }
begin
  if CSocket <> nil then CSocket.Close;
  CSocket := nil;
  MainForm.Close;
  MainForm.Release;
  if TCommonData.ReadInteger(OptionsSection, RememberMoreKey, 0) = 0
      then begin
    MoreStrings.Free;
    MoreStrings := nil;
  end;
  Caption := wartend;
 end;

 procedure TRootForm.FlushDatabases;
 begin
   if TCommonData.ReadInteger(OptionsSection, SaveHistoryKey, 0) <> 0 then
     TCommonData.Flush(HistorySection);
 end;

end.
